/**************************************************************
 *                                                            *
 *   Fichier : adler32.c                                      *
 *   Fonctions pour calculer le hash Adler32                  *
 *                                                            *
 **************************************************************/


#define BASE 65521 /* largest prime smaller than 65536 */


unsigned long Update_Adler32(unsigned long adler, unsigned char *buf, int len)
{
  unsigned long s1 = adler & 0xffff;
  unsigned long s2 = (adler >> 16) & 0xffff;
  int n;

  for (n = 0; n < len; n++) {
    s1 = (s1 + buf[n]) % BASE;
    s2 = (s2 + s1)     % BASE;
  }
  return (s2 << 16) + s1;
}

