/**************************************************************
 *                                                            *
 *   Fichier : fnv.c                                          *
 *   Fonction pour calculer le FNV32-64                       *
 *                                                            *
 **************************************************************/

/*
#define FNV32_0_INIT  CONST32(0x00000000)
#define FNV32_1_INIT  CONST32(0x811C9DC5)
#define FNV64_1_INIT  CONST64(0x84222325CBF29CE4)
#define FNV64_INIT = { 0x84222325, 0xcbf29ce4 }
#define FNV64a_INIT = { 0x84222325, 0xcbf29ce4 }
*/

#define FNV32_1_PRIME (0x01000193UL)
#define FNV64_1_PRIME (0x100000001B3ULL)

// 32
unsigned long Update_FNV32(unsigned long hash, unsigned char *buf, int len)
{
  unsigned long i;
  for(i = 0; i < len; i++) {
    hash *= FNV32_1_PRIME;
    hash ^= *buf++;
  }
  return hash;
}

// 64
unsigned long long Update_FNV64(unsigned long long hash, unsigned char *buf, int len)
{
  unsigned long i;
  for(i = 0; i < len; i++) {
    hash *= FNV64_1_PRIME;
    hash ^= *buf++;
  }
  return hash;
}
