/**************************************************************
 *                                                            *
 *  Hash Finder                                               *
 *   Version : 1.1.1.0                                        *
 *   Auteur : ordiman85                                       *
 *   Licence : Freeware & OpenSource                          *
 *                                                            *
 **************************************************************
 *                                                            *
 *   Description : Sert  trouver le hash d'un fichier        *
 *   Surpports : CRC16, CRC32, CRC64                         *
 *                Adler32, ELF32, ELF64                       *
 *                MD2, MD4, MD5                               *
 *                SHA-1, SHA-256, SHA-384, SHA-512            *
 *                RMD-128, RMD-160                            *
 *                HAVAL, HAVAL-3, HAVAL-4, HAVAL-5            *
 *                TIGER                                       *
 *                GOST                                        *
 *                                                            *
 **************************************************************
 *                                                            *
 *   Fichier : main.c                                         *
 *   Gre la fentre principale et la callback de celle-ci    *
 *                                                            *
 **************************************************************
 *                                                            *
 *   Amliorations :                                          *
 *                                                            *
 *   v1.1.1                                                   *
 *   + Support des lignes de commande (intgration possible)  *
 *                                                            *
 *   v1.1                                                     *
 *   + Vitesse nettement augmente !                          *
 *   + Ajout de CRC16, CRC64, ELF32, FNV32, FNV64 et HAVAL    *
 *   + Icone affiche en haut  gauche dans le titre          *
 *   + Affichage en majuscules auto aprs calcul              *
 *   * Test avec "abc" et 1 million de "a"                   *
 *   - Bugs de calcul importants retirs                      *
 *                                                            *
 *   v1.0.3                                                   *
 *   + Hash TIGER et GOST ajouts                             *
 *   - Bugs de calcul retirs                                 *
 *                                                            *
 *   v1.0                                                     *
 *   * Premire version                                       *
 *                                                            *
 **************************************************************/


/************
 * Includes *
 ************/

#include "main.h"


/***********************
 * Fonction principale *
 ***********************/

int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{

  // Rcupre la ligne de commande pour le calcul auto.
  strcpy(LigneCommande, lpCmdLine);

  /**************************
   * Cration de la fentre *
   **************************/
  MSG msg;
  WNDCLASS wc;
    wc.style = 0;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = NULL;
    wc.hIcon = LoadIcon(hinstance, "A");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(1 + COLOR_BTNFACE);
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = ProductWindowClass;
  if(!RegisterClass(&wc)) return FALSE;
  hwnd = CreateWindowEx(WS_EX_ACCEPTFILES, ProductWindowClass, ProductTitle, WS_SYSMENU,
         CW_USEDEFAULT, CW_USEDEFAULT, 350, 148, NULL, NULL, hinstance, NULL);
  if (!hwnd) return FALSE;
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  /*********************
   * Boucle principale *
   *********************/

  while (GetMessage(&msg, NULL, 0, 0)) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}


/********************
 * Callback Windows *
 ********************/

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

  // Handle des textes statiques (conomie de variables)
  static HWND Texte_Quelconque;
  // Utilise les fonctions de l'API pour rcuprer la taille de fentre
  RECT lpRect; GetClientRect(hwnd, &lpRect);
  long W_Width = lpRect.right; // Largeur de la fentre

  /************
   * Messages *
   ************/

  switch (uMsg) {

    /**************************
     * Cration des contrles *
     **************************/

    case WM_CREATE:
      // Texte Fichier :
      Texte_Quelconque = CreateWindow("static", "Fichier :", WS_VISIBLE|WS_CHILD,
        2, 3, MarginLeft-2, 16, hwnd, NULL, hinst, NULL); SetFont(Texte_Quelconque);
      // Texte Type :
      Texte_Quelconque = CreateWindow("static", "Type :", WS_VISIBLE|WS_CHILD,
        2, 29, MarginLeft-2, 16, hwnd, NULL, hinst, NULL); SetFont(Texte_Quelconque);
      // Champ du nom de fichier
      Champ_Fichier = CreateWindowEx(WS_EX_CLIENTEDGE, "edit", "", WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL,
        MarginLeft, 2, W_Width-MarginLeft-MarginRight, 20, hwnd, NULL, hinst, NULL); SetFont(Champ_Fichier);
      // Bouton Parcourir...
      Bouton_Parcourir = CreateWindow("button", "Parcourir...", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
        W_Width-MarginRight, 2, MarginRight-2, 20, hwnd, NULL, hinst, NULL); SetFont(Bouton_Parcourir);
      // ComboBox Type de Hash
      Selection_Type = CreateWindow("combobox", "ok", WS_CHILD | WS_VISIBLE |
        CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP,
        MarginLeft, 27, W_Width-MarginLeft-MarginRight, 150, hwnd, NULL, hinst, NULL);
      SetFont(Selection_Type);
      // Ajout d'lments
      SendMessage(Selection_Type, CB_RESETCONTENT, 0, 0);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_Adler32);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_CRC16);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_CRC32);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_CRC64);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_ELF32);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_FNV32);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_FNV64);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_GOST);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_HAVAL);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_HAVAL3);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_HAVAL4);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_HAVAL5);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_MD2);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_MD4);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_MD5);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_RMD128);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_RMD160);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_SHA1);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_SHA256);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_SHA384);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_SHA512);
      SendMessage(Selection_Type, CB_ADDSTRING, 0, (LONG)Nom_TIGER);
      // Bouton Calculer
      Bouton_Calculer = CreateWindow("button", "Calculer", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
        W_Width-MarginRight, 27, MarginRight-2, 20, hwnd, NULL, hinst, NULL); SetFont(Bouton_Calculer);
      // Champ du Hash
      Champ_Hash = CreateWindowEx(WS_EX_CLIENTEDGE, "edit", "Programm en C par ordiman85", WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | ES_READONLY,
        2, 72, W_Width-4, 20, hwnd, NULL, hinst, NULL); SetFont(Champ_Hash);
      // Checkbox Majuscules
      Bouton_Majuscules = CreateWindow("button", "Afficher en majuscules", BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
        2, 96, 150, 18, hwnd, NULL, hinst, NULL); SetFont(Bouton_Majuscules);
      // Barre de Progression
      Barre_Progression = CreateWindowEx(0, "msctls_progress32", (LPSTR)NULL, 1 | WS_CHILD | WS_VISIBLE,
        2, 54, W_Width-4, 12, hwnd, NULL, hinst, NULL);
        SendMessage(Barre_Progression, 1025, 0, MAKELPARAM(0, 100)); // 0 -> 100
      // Active le champ fichier
      SetFocus(Champ_Fichier);

      /*********************
       * Ligne de commande *
       *********************/

      // Si ligne de commande
      if (LigneCommande[0] != '\0') {
        // Variables
        unsigned int i = 0, j = 0; int type = -1;
        // t pour le type de hash et f pour le fichier
        char t[1024]; char f[1024];
        // Rcupre le type (avant l'espace)
        while (LigneCommande[i] != '\0' && LigneCommande[i] != ' ') {
          t[i] = LigneCommande[i]; i++;
        }
        t[i] = '\0'; // Termine la chane
        if (LigneCommande[i] == ' ') i++; // Esuqive l'espace
        // Fait un 'switch' des types possibles
        if (strcmp(t, "adler32") == 0) type = ID_Adler32;
        if (strcmp(t, "crc16") == 0) type = ID_CRC16;
        if (strcmp(t, "crc32") == 0) type = ID_CRC32;
        if (strcmp(t, "crc64") == 0) type = ID_CRC64;
        if (strcmp(t, "elf32") == 0) type = ID_ELF32;
        if (strcmp(t, "fnv32") == 0) type = ID_FNV32;
        if (strcmp(t, "fnv64") == 0) type = ID_FNV64;
        if (strcmp(t, "gost") == 0) type = ID_GOST;
        if (strcmp(t, "haval") == 0) type = ID_HAVAL;
        if (strcmp(t, "haval3") == 0) type = ID_HAVAL3;
        if (strcmp(t, "haval4") == 0) type = ID_HAVAL4;
        if (strcmp(t, "haval5") == 0) type = ID_HAVAL5;
        if (strcmp(t, "md2") == 0) type = ID_MD2;
        if (strcmp(t, "md4") == 0) type = ID_MD4;
        if (strcmp(t, "md5") == 0) type = ID_MD5;
        if (strcmp(t, "rmd128") == 0) type = ID_RMD128;
        if (strcmp(t, "rmd160") == 0) type = ID_RMD160;
        if (strcmp(t, "sha1") == 0) type = ID_SHA1;
        if (strcmp(t, "sha256") == 0) type = ID_SHA256;
        if (strcmp(t, "sha384") == 0) type = ID_SHA384;
        if (strcmp(t, "sha512") == 0) type = ID_SHA512;
        if (strcmp(t, "tiger") == 0) type = ID_TIGER;
        // Si un type est dtect
        if (type != -1) {
          SendMessage(Selection_Type, CB_SETCURSEL, type, 0L);
        } else {
          SendMessage(Selection_Type, CB_SETCURSEL, ID_Par_Defaut, 0L);
          i = 0; // Pas de type, donc la ligne correspondrait  un fichier ?
        }
        // Rcupre le fichier
        while (LigneCommande[i] != '\0') {
          f[j++] = LigneCommande[i]; i++;
        }
        f[j] = '\0'; // Termine la chane
        // Le nom de fichier est dans le Champ du Fichier
        SendMessage(Champ_Fichier, WM_SETTEXT, 0, (LPARAM)f);
        // Calcul si type dtect
        if (type != -1) OuvertureFichier(f);
      } else {
        // Pas de ligne de commande, slection par dfaut
        SendMessage(Selection_Type, CB_SETCURSEL, ID_Par_Defaut, 0L);
      }

      return 0;

    /**************
     * Evnements *
     **************/

    case WM_COMMAND:

      /*************
       * Parcourir *
       *************/
      if (lParam == (int)Bouton_Parcourir) {
        if (HIWORD(wParam) == BN_CLICKED) {
          char szFile[MAX_PATH] = ""; OPENFILENAME ofn;
          ZeroMemory(&ofn, sizeof(OPENFILENAME)); // On met tous les champs  zro
          ofn.lStructSize = sizeof(OPENFILENAME);
          ofn.hwndOwner = hwnd; ofn.lpstrTitle = "Ouvrir un fichier";
          ofn.lpstrInitialDir = ""; ofn.lpstrFilter = "Tous les fichiers (*.*)\0*.*\0";
          ofn.nFilterIndex = 0; ofn.lpstrFile = szFile;
          ofn.nMaxFile = sizeof(szFile); ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | 4;
          if (GetOpenFileName(&ofn))
            SendMessage(Champ_Fichier, WM_SETTEXT, 0, (LPARAM)szFile);
          return 0;
        }
      }

      /************
       * Calculer *
       ************/
      if (lParam == (int)Bouton_Calculer) {
        if (Etat == 0) {
          char* Fichier = GetWidgetText(Champ_Fichier); // Lit le contenu du champ fichier
          OuvertureFichier(Fichier);
          return 0;
        } else
          Annuler_Calcul(1);
      }

      /*************
       * Majuscules *
       *************/
      if (lParam == (int)Bouton_Majuscules) {
        Change_Majuscules();
      }

      return 0;


    /*********************
     * Glisser - Dposer *
     *********************/
    case WM_DROPFILES: {
      char szFile[255];
      // Rcupre le nom de fichier dans fname
      DragQueryFile((HDROP)wParam, 0, szFile, sizeof(szFile));
      // Modifie le champ fichier
      SendMessage(Champ_Fichier, WM_SETTEXT, 0, (LPARAM)szFile);
      // Drag and Drop termin
      DragFinish((HDROP) wParam);
      } return 0;


    /**********************
     * Fin des vnements *
     **********************/
    case WM_DESTROY:
      PostQuitMessage(0);
      return 0;
    default:
      return DefWindowProc(hwnd, uMsg, wParam, lParam);
  }
}


/***************************
 * Callback de progression *
 ***************************/

VOID CALLBACK ProgressProc(HWND hwnd, UINT uMsg, UINT_PTR Type, DWORD dwTime)
{
  if (Etat) {
    /************************
     * Barre de progression *
     ************************/
    unsigned long long Progression = 100; char temp[32];
    // Pour viter la division par zro (Progression = pourcentage de progression)
    if (Taille_Fichier != 0) {
      Progression *= Lecture; Progression /= Taille_Fichier;
    }
    sprintf(temp, "Veuillez patienter... %d%%", Progression);
    SendMessage(Champ_Hash, WM_SETTEXT, 0, (LPARAM)temp); // Champ du Hash
    SendMessage(Barre_Progression, 1026, Progression, 0); // Barre de progression
  }
}


/************************
 * Ouverture du fichier *
 ************************/

char OuvertureFichier(char* Fichier) {
  fp = fopen(Fichier, "rb"); // Lit le fichier si possible
  if (fp) { // Vrifie l'ouverture du fichier
    Taille_Fichier = fsize(fp);
    int Selection = SendMessage(Selection_Type, CB_GETCURSEL, 0, 0); // Rcupre le choix du type
    /****************************
     * Initialisation du calcul *
     ****************************/
    Type_Hash = Selection;
    InitHash();
    return 1;
  } else { // Fichier inaccessible
    MessageBox(hwnd, "Le fichier spcifi est inacessible", "Erreur", MB_OK|MB_ICONERROR);
  }
  return 0;
}



/********************
 * Dbut du hashing *
 ********************/

void InitHash()
{
  // Changement d'tat
  Etat = 1; Lecture = 0;
  // Type de hash
  switch (Type_Hash) {
    case ID_CRC16:
      Calcul16 = 0;
      break;
    case ID_CRC32:
      Calcul32 = 0L;
      break;
    case ID_Adler32:
      Calcul32 = 1L;
      break;
    case ID_ELF32:
      Calcul32 = 0L;
      break;
    case ID_FNV32:
      Calcul32 = FNV32_1_INIT;
      break;
    case ID_CRC64:
      Calcul64 = INITIALCRC64;
      break;
    case ID_FNV64:
      Calcul64 = FNV64_1_INIT;
      break;
    case ID_MD2:
      MD2Init(&MD2_Context);
      break;
    case ID_MD4:
      MD4Init(&MD4_Context);
      break;
    case ID_MD5:
      MD5Init(&MD5_Context);
      break;
    case ID_SHA1:
      SHA1Init(&SHA1_Context);
      break;
    case ID_SHA256:
      SHA256_Init(&SHA256_Context);
      break;
    case ID_SHA384:
      SHA384_Init(&SHA384_Context);
      break;
    case ID_SHA512:
      SHA512_Init(&SHA512_Context);
      break;
    case ID_RMD128:
      RMD128_Init(&RMD128_Context);
      break;
    case ID_RMD160:
      RMD160_Init(&RMD160_Context);
      break;
    case ID_HAVAL:
      HAVAL_Init(&HAVAL_Context, 3, 128);
      break;
    case ID_HAVAL3:
      HAVAL_Init(&HAVAL_Context, 3, 256);
      break;
    case ID_HAVAL4:
      HAVAL_Init(&HAVAL_Context, 4, 256);
      break;
    case ID_HAVAL5:
      HAVAL_Init(&HAVAL_Context, 5, 256);
      break;
    case ID_TIGER:
      TIGER_Init(&TIGER_Context);
      break;
    case ID_GOST:
      GOST_Init(&GOST_Context);
      break;
    default:
      MessageBox(NULL, "Mauvais ID ! Erreur de programmation", "Erreur", MB_OK|MB_ICONERROR);
      Annuler_Calcul(0);
      return;
  }
  // Changement du bouton Calculer
  SendMessage(Bouton_Calculer, WM_SETTEXT, 0, (LPARAM)"Annuler");
  // Timer pour la progression
  SetTimer(hwnd, 1000, Maj_Progression, (TIMERPROC)ProgressProc);
  // Procdure d'arrire plan pour le calcul
  _beginthread(HashProc, 0, (void *)hwnd);
}


/**********************
 * Callback de calcul *
 **********************/

void HashProc()
{
  while (Etat) {
    unsigned long long int len;
    unsigned char buffer[Taille_Tampon];
    /******************
      * Calcul du hash *
      ******************/
    if (len = fread(buffer, 1, Taille_Tampon, fp)) {
      unsigned long i, j;
      Lecture += len; // Progression
      switch (Type_Hash) {
        case ID_CRC16:
          Calcul16 = Update_CRC16(0xA001, Calcul16, buffer, len);
          break;
        case ID_CRC32:
          Calcul32 = Update_CRC32(Calcul32, buffer, len);
          break;
        case ID_Adler32:
          Calcul32 = Update_Adler32(Calcul32, buffer, len);
          break;
        case ID_ELF32:
          Calcul32 = Update_ELF32(Calcul32, buffer, len);
          break;
        case ID_FNV32:
          Calcul32 = Update_FNV32(Calcul32, buffer, len);
          break;
        case ID_CRC64:
          Calcul64 = Update_CRC64(Calcul64, buffer, len);
          break;
        case ID_FNV64:
          Calcul64 = Update_FNV64(Calcul64, buffer, len);
          break;
        case ID_MD2:
          MD2Update(&MD2_Context, buffer, len);
          break;
        case ID_MD4:
          MD4Update(&MD4_Context, buffer, len);
          break;
        case ID_MD5:
          MD5Update(&MD5_Context, buffer, len);
          break;
        case ID_SHA1:
          SHA1Update(&SHA1_Context, buffer, len);
          break;
        case ID_SHA256:
          SHA256_Update(&SHA256_Context, buffer, len);
          break;
        case ID_SHA384:
          SHA384_Update(&SHA384_Context, buffer, len);
          break;
        case ID_SHA512:
          SHA512_Update(&SHA512_Context, buffer, len);
          break;
        case ID_RMD128:
          RMD128_Update(&RMD128_Context, buffer, len);
          break;
        case ID_RMD160:
          RMD160_Update(&RMD160_Context, buffer, len);
          break;
        case ID_HAVAL:
        case ID_HAVAL3:
        case ID_HAVAL4:
        case ID_HAVAL5:
          HAVAL_Update(&HAVAL_Context, buffer, len);
          break;
        case ID_TIGER:
          TIGER_Update(&TIGER_Context, (byte*)buffer, len);
          break;
        case ID_GOST:
          GOST_Update(&GOST_Context, buffer, len);
          break;
      }
    } else
      FinalHash();
    // Libre la mmoire utilise
    LocalFree(buffer);
  }
  // Fin du processus et raz des controles
  Annuler_Calcul(0);
  _endthread();
}


/******************
 * Fin du hashing *
 ******************/

void FinalHash() {

  unsigned char Checksum[1024] = "";
  //unsigned char *Checksum = "";
  int i, j;

  switch (Type_Hash) {

    // 16
    case ID_CRC16: {
      // Conversion en hexadcimal
      sprintf(Checksum, "%04x", Calcul16);
    } break;

    // 32
    case ID_CRC32:
    case ID_Adler32:
    case ID_ELF32:
    case ID_FNV32: {
      // Conversion en hexadcimal
      sprintf(Checksum, "%08x", Calcul32);
    } break;

    // 64
    case ID_CRC64:
    case ID_FNV64: {
      // Conversion int64 en hexadcimal
#ifdef ___ReHash_Code___
      if (Type_Hash == ID_CRC64) Calcul64 = ~Calcul64;
#endif
      Hash64_End(Calcul64, Checksum);
    } break;

    // MD-2-4-5
    case ID_MD2:
    case ID_MD4:
    case ID_MD5: {
      // Variables
      unsigned char digest[16], temp[3];
      // Finalisation
      if (Type_Hash == ID_MD2) MD2Final(digest, &MD2_Context);
      if (Type_Hash == ID_MD4) MD4Final(digest, &MD4_Context);
      if (Type_Hash == ID_MD5) MD5Final(digest, &MD5_Context);
      // Reconstitution du hash
      for (i = 0; i < 16; i++) {
        sprintf(temp, "%02x", digest[i]); strcat(Checksum, temp);
      }
    } break;

    // SHA-1
    case ID_SHA1: {
      // Variables
      unsigned char digest[20]; int len;
      // Finalisation
      SHA1Final(digest, &SHA1_Context); len = 20;
      // Chaine Temp
      unsigned char temp[3];
      // Reconstitution du hash
      for (i = 0; i < len; i++) {
        sprintf(temp, "%02x", digest[i]); strcat(Checksum, temp);
      }
    } break;

    // SHA-256-384-512
    case ID_SHA256:
      SHA256_End(&SHA256_Context, Checksum);
      break;
    case ID_SHA384:
      SHA384_End(&SHA384_Context, Checksum);
      break;
    case ID_SHA512:
      SHA512_End(&SHA512_Context, Checksum);
      break;

    // RMD-128-160
    case ID_RMD128: {
      RMD128_End(&RMD128_Context, Checksum);
    } break;
    case ID_RMD160: {
      RMD160_End(&RMD160_Context, Checksum);
    } break;

    // HAVAL
    case ID_HAVAL:
    case ID_HAVAL3:
    case ID_HAVAL4:
    case ID_HAVAL5: {
      int len;
      if (Type_Hash == ID_HAVAL) len = 16;
      if (Type_Hash == ID_HAVAL3 ||
          Type_Hash == ID_HAVAL4 ||
          Type_Hash == ID_HAVAL5) len = 32;
      byte digest[256]; unsigned char temp[3];
      HAVAL_Final(&HAVAL_Context, digest);
      for (i = 0; i < len; i++) {
        sprintf(temp, "%02x", digest[i]); strcat(Checksum, temp);
      }
    } break;

    // TIGER
    case ID_TIGER: {
      // Chaine Temp
      char len = 24; unsigned char digest[24]; unsigned char temp[3];
      // Finalisation du hash
      TIGER_End(&TIGER_Context, &(*digest));
      // Conversion en hexadcimal
      for (i = 0; i < 24; i++) {
        sprintf(temp, "%02x", digest[i]); strcat(Checksum, temp);
      }
    } break;

    // GOST
    case ID_GOST: {
      // Chaine Temp
      int len = 32; unsigned char temp[len*2]; unsigned char digest[len];
      GOST_Final(&GOST_Context, digest);
      for (i = 0; i < len; i++) {
        sprintf(temp, "%02x", digest[i]); strcat(Checksum, temp);
      }
    } break;

  }

  // Copie du hash dans la variable globale
  strcpy(Global_Hash, Checksum);
  // Termine l'affichage de progression
  Annuler_Calcul(0);
  // Affichage + majuscules ?
  Change_Majuscules();
}


// Procdure d'annulation
void Annuler_Calcul(char Annuler)
{
  // Rinitialisation
  Etat = 0; Lecture = 0; fclose(fp);
  if (Annuler)
    SendMessage(Champ_Hash, WM_SETTEXT, 0, (LPARAM)"Opration annule");
  SendMessage(Bouton_Calculer, WM_SETTEXT, 0, (LPARAM)"Calculer");
  // Fin du timer de mise  jour de la progression
  KillTimer(hwnd, 1000);
  // Remise  zro de la barre de progression
  SendMessage(Barre_Progression, 1026, 0, 0);
}


/*********************
 * Fonctions Gadgets *
 *********************/

// Attribut de police
void SetFont(HWND gad)
{
  SendMessage(gad, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), MAKELPARAM(TRUE, 0));
}

// Retourne le contenu d'un widget
char *GetWidgetText(HWND gad)
{
  unsigned int TextLen = 0;
  char* Text;
  TextLen = GetWindowTextLength(gad);
  Text = (char*)GlobalAlloc(64, TextLen + 1);
  if (TextLen) {
    TextLen = GetWindowText(gad, Text, (TextLen + 1));
  }
  return Text;
}

/************************
 * Gestion des fichiers *
 ************************/

// Taille du fichier binaire
long fsize(FILE* fd)
{
   long savepos, size;
   savepos = ftell(fd);          // sauvegarder la position
   fseek(fd, 0, SEEK_END);       // aller en fin
   size = ftell(fd);             // lire la taille
   fseek(fd, savepos, SEEK_SET); // rtablir la position
   return size;
}

/**************************
 * Gestion des caractres *
 **************************/

// Maj du champ du hash
void Change_Majuscules()
{
  if (SendMessage(Bouton_Majuscules, BM_GETCHECK, 0, 0) == BST_CHECKED) {
    // Conversion en majuscules
    int i = 0; while (Global_Hash[i]) { Global_Hash[i] = MinMaj(Global_Hash[i]); i++; }
  } else {
    // Conversion en minuscules
    int i=0; while (Global_Hash[i]) { Global_Hash[i] = MajMin(Global_Hash[i]); i++; }
  }
  // Affichage du hash
  SendMessage(Champ_Hash, WM_SETTEXT, 0, (LPARAM)Global_Hash);
  // Slectionne tout le hash
  SendMessage(Champ_Hash, EM_SETSEL, 0, 99999); SetFocus(Champ_Hash);
}

char MinMaj(char c)
{
 if((c >='a') && (c <='z'))
   c-=' ';
 return c;
}

char MajMin(char c)
{
 if((c >='A') && (c <='Z'))
   c+=' ';
 return c;
}

/* Fin du fichier --- main.c --- */
